-- 
-- Create Date:    20:28:22 10/04/2010 
-- Module Name:    ad_downsampler - Behavioral 
-- Description:	 Send ut en nye oppdatering med frekvens 10Hz, ned fra new_values fra ad_formatconv med frekvens 200000Hz.
--
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
USE ieee.std_logic_unsigned.all;

entity ad_downsampler is
    Port ( ad_a, ad_b : in  STD_LOGIC_VECTOR (7 downto 0);
           new_values : in  STD_LOGIC;
           speed, direction : out  STD_LOGIC_VECTOR (7 downto 0);
           update : out  STD_LOGIC);
end ad_downsampler;

architecture Behavioral of ad_downsampler is
	signal a : integer range 0 to 20000:=0; 
begin
	process (new_values)
	begin
		if new_values'EVENT and new_values = '1' then

		-- 200000 Hz in, vil ha 10 Hz ut
		-- 200 000 / 10 = 20 000 - 1 ventepulser
			if a = 19999 then
				speed <= ad_b;
				direction <= ad_a;
				update <= '1';
				a <= 0;
			elsif a >= 1 then
				update <= '0';
				a <= a+1;
			else
				a <= a+1;
			end if;
			
		end if;
	end process;
end Behavioral;
