--
-- Create Date:    19:11:09 09/29/2010 
-- Module Name:    ad_snm
-- Description:	 14-bit 2'komplement til msb 8-bit Sign-and-Magnitude
--
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

entity ad_snm is
    Port ( ad_in : in  STD_LOGIC_VECTOR (13 downto 0);
           ad_out : out  STD_LOGIC_VECTOR (7 downto 0);
			  ad_out_un : out  STD_LOGIC_VECTOR(5 downto 0));
end ad_snm;

architecture Behavior of ad_snm is
	signal m : STD_LOGIC_VECTOR(7 downto 0);
begin

   -- bruk de 8-bit mest signifikante bitene fra 14-bit input
	m <= ad_in(13) & ad_in(12) & ad_in(11) & ad_in(10) & ad_in(9) & ad_in(8) & ad_in(7) & ad_in(6);
	-- ubrukte bit settes til ad_out_unused for  unng "not connected" melding
	ad_out_un <= ad_in(5) & ad_in(4) & ad_in(3) & ad_in(2) & ad_in(1) & ad_in(0);
	process (m)
	begin
			if (m(7) = '1') then
				ad_out <= m(7) & NOT m(6) & NOT m(5) & NOT m(4) & NOT m(3) & NOT m(2) & NOT m(1) & NOT m(0);
			else
				ad_out <= m;
			end if;
	end process;
end Behavior;

