-- 
-- Create Date:    20:25:10 10/04/2010 
-- Module Name:    baud_rate - Behavioral 
-- Description:	 Lag en ny klokke som er 4 klokkeflanker for hver bit p et 57600 bits/s signal, fra en 50 MHz klokke
--
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
USE ieee.std_logic_unsigned.all;

entity baud_rate is
    Port ( clk : in  STD_LOGIC;
           clk_4b : out  STD_LOGIC);
end baud_rate;

architecture Behavioral of baud_rate is
	signal a : integer range 0 to 217:=0;
begin
	process (clk)
	begin
		if clk'EVENT and clk = '1' then
		-- 1 / 50000000 = 20ns periode
		-- 1 / 57600 = 17.36111us / 4 = 4.3402777us
		-- (50000000 / 57600) / 4 = 217 - 1
			if a = 216 then
				-- klokkepulse
				clk_4b <= '1';
				a <= 0;
			elsif a >= 1 then
				clk_4b <= '0';
				a <= a+1;
			else
				a <= a+1;
			end if;
		end if;
	end process;

end Behavioral;

