-- 
-- Create Date:    20:27:23 10/28/2010 
-- Module Name:    control_hub - Behavioral 
-- Description:    Koble innsignaler for  forme msc databuss og tolke rx_byte retur databus
--
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

entity control_hub is
    Port ( clk_4b, sw_power, sw_dir, sw_spd, msc1, msc2, msc3, msc4, msc5 : in  STD_LOGIC;
	        rx_byte : in  STD_LOGIC_VECTOR (7 downto 0);
           msc : out  STD_LOGIC_VECTOR (7 downto 0);
			  status : out  STD_LOGIC:='0');
end control_hub;

architecture Behavioral of control_hub is
   signal power : STD_LOGIC:='0';
begin
	process (clk_4b, rx_byte, sw_power)
		begin
			if (clk_4b'EVENT and clk_4b = '1') then
				--if rx_byte(0) = '1' then
				--	-- hvis ir detektor er nrme en motstand, stopp styreenheten
				--	power <= '0';
				--els
				if sw_power = '1' then
					-- hvis svitsj p stryringskort er sltt p, send start/stopp signal
					power <= '1';
				else
					-- ellers stopp styreenhet
					power <= '0';
				end if;
				
				-- sett indikatorlys p styringskort
				if rx_byte(7) = '1' then
					status <= '1';
				else 
					status <= '0';
				end if;
			end if;
	end process;
	
	msc <= power & msc5 & msc4 & msc3 & msc2 & sw_dir & sw_spd & msc1;
end Behavioral;

