--------------------------------------------------------------------------------
-- Copyright (c) 1995-2010 Xilinx, Inc.  All rights reserved.
--------------------------------------------------------------------------------
--   ____  ____ 
--  /   /\/   / 
-- /___/  \  /    Vendor: Xilinx 
-- \   \   \/     Version : 12.2
--  \   \         Application : sch2hdl
--  /   /         Filename : debugging.vhf
-- /___/   /\     Timestamp : 10/29/2010 13:08:11
-- \   \  /  \ 
--  \___\/\___\ 
--
--Command: sch2hdl -intstyle ise -family spartan3e -flat -suppress -vhdl E:/prosjekt_vhdl/debugging.vhf -w E:/prosjekt_vhdl/debugging.sch
--Design Name: debugging
--Device: spartan3e
--Purpose:
--    This vhdl netlist is translated from an ECS schematic. It can be 
--    synthesized and simulated, but it should not be modified. 
--

library ieee;
use ieee.std_logic_1164.ALL;
use ieee.numeric_std.ALL;
library UNISIM;
use UNISIM.Vcomponents.ALL;

entity debugging is
   port ( CLK_50MHZ   : in    std_logic; 
          SPI_MISO    : in    std_logic; 
          AD_CONV     : out   std_logic; 
          AMP_CS      : out   std_logic; 
          FPGA_INIT_B : out   std_logic; 
          FX2_IO4     : out   std_logic; 
          FX2_IO25    : out   std_logic; 
          SF_CE0      : out   std_logic; 
          SPI_MOSI    : out   std_logic; 
          SPI_SCK     : out   std_logic; 
          SPI_SS_B    : out   std_logic; 
          XLXN_233    : out   std_logic_vector (5 downto 0); 
          XLXN_234    : out   std_logic_vector (5 downto 0));
end debugging;

architecture BEHAVIORAL of debugging is
   signal XLXN_32                          : std_logic;
   signal XLXN_215                         : std_logic_vector (13 downto 0);
   signal XLXN_216                         : std_logic_vector (13 downto 0);
   signal XLXN_217                         : std_logic_vector (7 downto 0);
   signal XLXN_218                         : std_logic_vector (7 downto 0);
   signal XLXN_227                         : std_logic_vector (7 downto 0);
   signal XLXN_228                         : std_logic_vector (7 downto 0);
   signal XLXN_303                         : std_logic;
   signal XLXN_415                         : std_logic;
   signal XLXI_12_error_openSignal         : std_logic;
   signal XLXI_12_msc_openSignal           : std_logic_vector (7 downto 0);
   signal XLXI_12_rx_openSignal            : std_logic;
   signal XLXI_12_timer_expired_openSignal : std_logic;
   component compact_ad
      port ( clk_50      : in    std_logic; 
             spi_miso    : in    std_logic; 
             new_values  : out   std_logic; 
             amp_cs      : out   std_logic; 
             ad_buzy     : out   std_logic; 
             ad_conv     : out   std_logic; 
             spi_sck     : out   std_logic; 
             spi_mosi    : out   std_logic; 
             spi_ss_b    : out   std_logic; 
             sf_ce0      : out   std_logic; 
             fpga_init_b : out   std_logic; 
             ad_a        : out   std_logic_vector (13 downto 0); 
             ad_b        : out   std_logic_vector (13 downto 0));
   end component;
   
   component ad_downsampler
      port ( new_values : in    std_logic; 
             update     : out   std_logic; 
             speed      : out   std_logic_vector (7 downto 0); 
             direction  : out   std_logic_vector (7 downto 0); 
             ad_a       : in    std_logic_vector (7 downto 0); 
             ad_b       : in    std_logic_vector (7 downto 0));
   end component;
   
   component baud_rate
      port ( clk    : in    std_logic; 
             clk_4b : out   std_logic);
   end component;
   
   component ad_formatconv
      port ( ad_a_in         : in    std_logic_vector (13 downto 0); 
             ad_b_in         : in    std_logic_vector (13 downto 0); 
             ad_a_out        : out   std_logic_vector (7 downto 0); 
             ad_b_out        : out   std_logic_vector (7 downto 0); 
             ad_a_out_unused : out   std_logic_vector (5 downto 0); 
             ad_b_out_unused : out   std_logic_vector (5 downto 0));
   end component;
   
   component tx_rx_module
      port ( rx            : in    std_logic; 
             error         : in    std_logic; 
             update        : in    std_logic; 
             clk_4b        : in    std_logic; 
             spd           : in    std_logic_vector (7 downto 0); 
             dir           : in    std_logic_vector (7 downto 0); 
             msc           : in    std_logic_vector (7 downto 0); 
             tx            : out   std_logic; 
             linestatus    : out   std_logic; 
             start_timer   : out   std_logic; 
             stop_timer    : out   std_logic; 
             rx_byte       : out   std_logic_vector (7 downto 0); 
             timer_expired : in    std_logic);
   end component;
   
begin
   XLXI_3 : compact_ad
      port map (clk_50=>CLK_50MHZ,
                spi_miso=>SPI_MISO,
                ad_a(13 downto 0)=>XLXN_215(13 downto 0),
                ad_b(13 downto 0)=>XLXN_216(13 downto 0),
                ad_buzy=>FX2_IO25,
                ad_conv=>AD_CONV,
                amp_cs=>AMP_CS,
                fpga_init_b=>FPGA_INIT_B,
                new_values=>XLXN_303,
                sf_ce0=>SF_CE0,
                spi_mosi=>SPI_MOSI,
                spi_sck=>SPI_SCK,
                spi_ss_b=>SPI_SS_B);
   
   XLXI_6 : ad_downsampler
      port map (ad_a(7 downto 0)=>XLXN_217(7 downto 0),
                ad_b(7 downto 0)=>XLXN_218(7 downto 0),
                new_values=>XLXN_303,
                direction(7 downto 0)=>XLXN_228(7 downto 0),
                speed(7 downto 0)=>XLXN_227(7 downto 0),
                update=>XLXN_32);
   
   XLXI_8 : baud_rate
      port map (clk=>CLK_50MHZ,
                clk_4b=>XLXN_415);
   
   XLXI_10 : ad_formatconv
      port map (ad_a_in(13 downto 0)=>XLXN_215(13 downto 0),
                ad_b_in(13 downto 0)=>XLXN_216(13 downto 0),
                ad_a_out(7 downto 0)=>XLXN_217(7 downto 0),
                ad_a_out_unused(5 downto 0)=>XLXN_234(5 downto 0),
                ad_b_out(7 downto 0)=>XLXN_218(7 downto 0),
                ad_b_out_unused(5 downto 0)=>XLXN_233(5 downto 0));
   
   XLXI_12 : tx_rx_module
      port map (clk_4b=>XLXN_415,
                dir(7 downto 0)=>XLXN_228(7 downto 0),
                error=>XLXI_12_error_openSignal,
                msc(7 downto 0)=>XLXI_12_msc_openSignal(7 downto 0),
                rx=>XLXI_12_rx_openSignal,
                spd(7 downto 0)=>XLXN_227(7 downto 0),
                timer_expired=>XLXI_12_timer_expired_openSignal,
                update=>XLXN_32,
                linestatus=>open,
                rx_byte=>open,
                start_timer=>open,
                stop_timer=>open,
                tx=>FX2_IO4);
   
end BEHAVIORAL;


