--------------------------------------------------------------------------------
-- Copyright (c) 1995-2010 Xilinx, Inc.  All rights reserved.
--------------------------------------------------------------------------------
--   ____  ____ 
--  /   /\/   / 
-- /___/  \  /    Vendor: Xilinx 
-- \   \   \/     Version : 12.2
--  \   \         Application : sch2hdl
--  /   /         Filename : kontroller.vhf
-- /___/   /\     Timestamp : 11/19/2010 12:19:21
-- \   \  /  \ 
--  \___\/\___\ 
--
--Command: sch2hdl -intstyle ise -family spartan3e -flat -suppress -vhdl E:/prosjekt_vhdl/kontroller.vhf -w E:/prosjekt_vhdl/kontroller.sch
--Design Name: kontroller
--Device: spartan3e
--Purpose:
--    This vhdl netlist is translated from an ECS schematic. It can be 
--    synthesized and simulated, but it should not be modified. 
--

library ieee;
use ieee.std_logic_1164.ALL;
use ieee.numeric_std.ALL;
library UNISIM;
use UNISIM.Vcomponents.ALL;

entity kontroller is
   port ( BTN_EAST    : in    std_logic; 
          BTN_NORTH   : in    std_logic; 
          BTN_SOUTH   : in    std_logic; 
          BTN_WEST    : in    std_logic; 
          CLK_50MHZ   : in    std_logic; 
          FX2_IO2     : in    std_logic; 
          FX2_IO4     : in    std_logic; 
          FX2_IO5     : in    std_logic; 
          FX2_IO6     : in    std_logic; 
          FX2_IO7     : in    std_logic; 
          FX2_IO8     : in    std_logic; 
          FX2_IO21    : in    std_logic; 
          FX2_IO22    : in    std_logic; 
          FX2_IO23    : in    std_logic; 
          FX2_IO24    : in    std_logic; 
          SPI_MISO    : in    std_logic; 
          SW          : in    std_logic_vector (3 downto 0); 
          AD_CONV     : out   std_logic; 
          AMP_CS      : out   std_logic; 
          FPGA_INIT_B : out   std_logic; 
          FX2_IO1     : out   std_logic; 
          FX2_IO3     : out   std_logic; 
          FX2_IO9     : out   std_logic; 
          FX2_IO11    : out   std_logic; 
          FX2_IO25    : out   std_logic; 
          LED         : out   std_logic_vector (7 downto 0); 
          SF_CE0      : out   std_logic; 
          SPI_MOSI    : out   std_logic; 
          SPI_SCK     : out   std_logic; 
          SPI_SS_B    : out   std_logic; 
          XLXN_430    : out   std_logic_vector (5 downto 0); 
          XLXN_431    : out   std_logic_vector (5 downto 0));
end kontroller;

architecture BEHAVIORAL of kontroller is
   signal XLXN_23       : std_logic;
   signal XLXN_32       : std_logic;
   signal XLXN_33       : std_logic;
   signal XLXN_215      : std_logic_vector (13 downto 0);
   signal XLXN_216      : std_logic_vector (13 downto 0);
   signal XLXN_227      : std_logic_vector (7 downto 0);
   signal XLXN_228      : std_logic_vector (7 downto 0);
   signal XLXN_332      : std_logic_vector (7 downto 0);
   signal XLXN_333      : std_logic_vector (7 downto 0);
   signal XLXN_410      : std_logic;
   signal XLXN_420      : std_logic_vector (7 downto 0);
   signal XLXN_421      : std_logic_vector (7 downto 0);
   signal XLXN_438      : std_logic;
   signal XLXN_689      : std_logic;
   signal LED_DUMMY     : std_logic_vector (7 downto 0);
   signal FX2_IO1_DUMMY : std_logic;
   component compact_ad
      port ( clk_50      : in    std_logic; 
             spi_miso    : in    std_logic; 
             new_values  : out   std_logic; 
             amp_cs      : out   std_logic; 
             ad_buzy     : out   std_logic; 
             ad_conv     : out   std_logic; 
             spi_sck     : out   std_logic; 
             spi_mosi    : out   std_logic; 
             spi_ss_b    : out   std_logic; 
             sf_ce0      : out   std_logic; 
             fpga_init_b : out   std_logic; 
             ad_a        : out   std_logic_vector (13 downto 0); 
             ad_b        : out   std_logic_vector (13 downto 0));
   end component;
   
   component ad_downsampler
      port ( new_values : in    std_logic; 
             ad_a       : in    std_logic_vector (7 downto 0); 
             ad_b       : in    std_logic_vector (7 downto 0); 
             update     : out   std_logic; 
             speed      : out   std_logic_vector (7 downto 0); 
             direction  : out   std_logic_vector (7 downto 0));
   end component;
   
   component baud_rate
      port ( clk    : in    std_logic; 
             clk_4b : out   std_logic);
   end component;
   
   component rx_timer
      port ( start_timer   : in    std_logic; 
             stop_timer    : in    std_logic; 
             clk           : in    std_logic; 
             timer_expired : out   std_logic);
   end component;
   
   component ad_formatconv
      port ( ad_a_in         : in    std_logic_vector (13 downto 0); 
             ad_b_in         : in    std_logic_vector (13 downto 0); 
             ad_a_out        : out   std_logic_vector (7 downto 0); 
             ad_b_out        : out   std_logic_vector (7 downto 0); 
             ad_b_out_unused : out   std_logic_vector (5 downto 0); 
             ad_a_out_unused : out   std_logic_vector (5 downto 0));
   end component;
   
   component tx_rx_module
      port ( rx            : in    std_logic; 
             timer_expired : in    std_logic; 
             error         : in    std_logic; 
             update        : in    std_logic; 
             clk_4b        : in    std_logic; 
             spd           : in    std_logic_vector (7 downto 0); 
             dir           : in    std_logic_vector (7 downto 0); 
             msc           : in    std_logic_vector (7 downto 0); 
             tx            : out   std_logic; 
             linestatus    : out   std_logic; 
             start_timer   : out   std_logic; 
             rx_byte       : out   std_logic_vector (7 downto 0); 
             stop_timer    : out   std_logic);
   end component;
   
   component test_rx
      port ( clk_4b    : in    std_logic; 
             direction : in    std_logic; 
             div       : in    std_logic_vector (7 downto 0); 
             test_rx   : out   std_logic);
   end component;
   
   component tx_test_pins
      port ( btn_north : in    std_logic; 
             btn_south : in    std_logic; 
             btn_west  : in    std_logic; 
             btn_east  : in    std_logic; 
             switch    : in    std_logic_vector (3 downto 0); 
             direction : out   std_logic_vector (7 downto 0));
   end component;
   
   component control_hub
      port ( clk_4b   : in    std_logic; 
             sw_power : in    std_logic; 
             sw_dir   : in    std_logic; 
             sw_spd   : in    std_logic; 
             msc1     : in    std_logic; 
             msc2     : in    std_logic; 
             msc3     : in    std_logic; 
             msc4     : in    std_logic; 
             msc5     : in    std_logic; 
             rx_byte  : in    std_logic_vector (7 downto 0); 
             status   : out   std_logic; 
             msc      : out   std_logic_vector (7 downto 0));
   end component;
   
begin
   FX2_IO1 <= FX2_IO1_DUMMY;
   LED(7 downto 0) <= LED_DUMMY(7 downto 0);
   XLXI_3 : compact_ad
      port map (clk_50=>CLK_50MHZ,
                spi_miso=>SPI_MISO,
                ad_a(13 downto 0)=>XLXN_215(13 downto 0),
                ad_b(13 downto 0)=>XLXN_216(13 downto 0),
                ad_buzy=>FX2_IO25,
                ad_conv=>AD_CONV,
                amp_cs=>AMP_CS,
                fpga_init_b=>FPGA_INIT_B,
                new_values=>XLXN_438,
                sf_ce0=>SF_CE0,
                spi_mosi=>SPI_MOSI,
                spi_sck=>SPI_SCK,
                spi_ss_b=>SPI_SS_B);
   
   XLXI_6 : ad_downsampler
      port map (ad_a(7 downto 0)=>XLXN_332(7 downto 0),
                ad_b(7 downto 0)=>XLXN_333(7 downto 0),
                new_values=>XLXN_438,
                direction(7 downto 0)=>XLXN_228(7 downto 0),
                speed(7 downto 0)=>XLXN_227(7 downto 0),
                update=>XLXN_32);
   
   XLXI_8 : baud_rate
      port map (clk=>CLK_50MHZ,
                clk_4b=>XLXN_410);
   
   XLXI_9 : rx_timer
      port map (clk=>CLK_50MHZ,
                start_timer=>XLXN_23,
                stop_timer=>XLXN_689,
                timer_expired=>XLXN_33);
   
   XLXI_10 : ad_formatconv
      port map (ad_a_in(13 downto 0)=>XLXN_215(13 downto 0),
                ad_b_in(13 downto 0)=>XLXN_216(13 downto 0),
                ad_a_out(7 downto 0)=>XLXN_332(7 downto 0),
                ad_a_out_unused(5 downto 0)=>XLXN_430(5 downto 0),
                ad_b_out(7 downto 0)=>XLXN_333(7 downto 0),
                ad_b_out_unused(5 downto 0)=>XLXN_431(5 downto 0));
   
   XLXI_12 : tx_rx_module
      port map (clk_4b=>XLXN_410,
                dir(7 downto 0)=>XLXN_228(7 downto 0),
                error=>FX2_IO2,
                msc(7 downto 0)=>XLXN_421(7 downto 0),
                rx=>FX2_IO4,
                spd(7 downto 0)=>XLXN_227(7 downto 0),
                timer_expired=>XLXN_33,
                update=>XLXN_32,
                linestatus=>FX2_IO1_DUMMY,
                rx_byte(7 downto 0)=>LED_DUMMY(7 downto 0),
                start_timer=>XLXN_23,
                stop_timer=>XLXN_689,
                tx=>FX2_IO3);
   
   XLXI_14 : test_rx
      port map (clk_4b=>XLXN_410,
                direction=>FX2_IO1_DUMMY,
                div(7 downto 0)=>XLXN_420(7 downto 0),
                test_rx=>FX2_IO11);
   
   XLXI_15 : tx_test_pins
      port map (btn_east=>BTN_EAST,
                btn_north=>BTN_NORTH,
                btn_south=>BTN_SOUTH,
                btn_west=>BTN_WEST,
                switch(3 downto 0)=>SW(3 downto 0),
                direction(7 downto 0)=>XLXN_420(7 downto 0));
   
   XLXI_18 : control_hub
      port map (clk_4b=>XLXN_410,
                msc1=>FX2_IO8,
                msc2=>FX2_IO21,
                msc3=>FX2_IO22,
                msc4=>FX2_IO23,
                msc5=>FX2_IO24,
                rx_byte(7 downto 0)=>LED_DUMMY(7 downto 0),
                sw_dir=>FX2_IO5,
                sw_power=>FX2_IO7,
                sw_spd=>FX2_IO6,
                msc(7 downto 0)=>XLXN_421(7 downto 0),
                status=>FX2_IO9);
   
end BEHAVIORAL;


