-- 
-- Create Date:    20:27:23 10/28/2010 
-- Module Name:    tx_msc_hub - Behavioral 
-- Description:    Koble innsignaler for  forme msc databus
--
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

entity msc_hub is
    Port ( clk_4b, sw_power, sw_dir, sw_spd, msc1, msc2, msc3, msc4, msc5 : in  STD_LOGIC;
	        rx_byte : in  STD_LOGIC_VECTOR (7 downto 0);
           msc : out  STD_LOGIC_VECTOR (7 downto 0);
			  rx_byte_out : out  STD_LOGIC_VECTOR (7 downto 0));
end msc_hub;

architecture Behavioral of msc_hub is

   signal power : STD_LOGIC:='0';

begin
	process (clk_4b, rx_byte, sw_power)
		begin
			if (clk_4b'EVENT and clk_4b = '1') then
				if rx_byte(0) = '1' then
					power <= '0';
				elsif sw_power = '1' then
					power <= '1';
				else
					power <= '0';
				end if;
			end if;
	end process;
	rx_byte_out <= rx_byte;
	msc <= power & msc5 & msc4 & msc3 & msc2 & sw_dir & sw_spd & msc1;
end Behavioral;

