-- 
-- Create Date:    20:23:53 10/04/2010 
-- Module Name:    rx_timer - Behavioral 
-- Description:    Motta rx timer, etter siste tx stopp-bit, vent 25 ms for  motta frste startbit fra rx styreenhet
--
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

entity rx_timer is
    Port ( start_timer, stop_timer, clk : in  STD_LOGIC;
           timer_expired : out  STD_LOGIC:='0');
end rx_timer;

architecture Behavioral of rx_timer is
	signal a : integer range 0 to 31250:=0;
   signal timer_init : STD_LOGIC:='0';
begin
	process (stop_timer,start_timer,clk)
	begin	
	
		if clk'EVENT and clk = '1' then
		
			if stop_timer = '1' then
				a <= 0;
				timer_init <= '0';
			elsif start_timer = '1' then
				timer_init <= '1';
			end if;

			if timer_init = '1' then
				-- 1/50000000 = 0.00000002 (20ns) pulse
				-- 0.025 (25ms) / 0.00000002 (20ns) = 31250 ventepulser
				if a = 31249 then
					timer_expired <= '1';
					a <= 0;
				else
					timer_expired <= '0';
					a <= a+1;
				end if;					
			end if;
		end if;

				
	end process;
end Behavioral;

