--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:   12:27:30 10/22/2010
-- Design Name:   
-- Module Name:   E:/prosjekt_vhd/tx_rx_module_tb.vhd
-- Project Name:  prosjekt
-- Target Device:  
-- Tool versions:  
-- Description:   
-- 
-- VHDL Test Bench Created by ISE for module: tx_rx_module
-- 
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
--
-- Notes: 
-- This testbench has been automatically generated using types std_logic and
-- std_logic_vector for the ports of the unit under test.  Xilinx recommends
-- that these types always be used for the top-level I/O of a design in order
-- to guarantee that the testbench will bind correctly to the post-implementation 
-- simulation model.
--------------------------------------------------------------------------------
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
 
-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--USE ieee.numeric_std.ALL;
 
ENTITY tx_rx_module_tb IS
END tx_rx_module_tb;
 
ARCHITECTURE behavior OF tx_rx_module_tb IS 
 
    -- Component Declaration for the Unit Under Test (UUT)
 
    COMPONENT tx_rx_module
    PORT(
         spd : IN  std_logic_vector(7 downto 0);
         dir : IN  std_logic_vector(7 downto 0);
         msc : IN  std_logic_vector(7 downto 0);
         rx : IN  std_logic;
         timer_expired : IN  std_logic;
         error : IN  std_logic;
         update : IN  std_logic;
         clk_4b : IN  std_logic;
         rx_byte : OUT  std_logic_vector(7 downto 0);
         tx : OUT  std_logic;
         linestatus : OUT  std_logic;
         start_timer : OUT  std_logic;
         stop_timer : OUT  std_logic
        );
    END COMPONENT;
    

   --Inputs
   signal spd : std_logic_vector(7 downto 0) := (others => '0');
   signal dir : std_logic_vector(7 downto 0) := (others => '0');
   signal msc : std_logic_vector(7 downto 0) := (others => '0');
   signal rx : std_logic := '0';
   signal timer_expired : std_logic := '0';
   signal error : std_logic := '0';
   signal update : std_logic := '0';
   signal clk_4b : std_logic := '0';

 	--Outputs
   signal rx_byte : std_logic_vector(7 downto 0);
   signal tx : std_logic;
   signal linestatus : std_logic;
   signal start_timer : std_logic;
   signal stop_timer : std_logic;

   -- Clock period definitions
   constant clk_4b_period : time := 10 ns;
 
BEGIN
 
	-- Instantiate the Unit Under Test (UUT)
   uut: tx_rx_module PORT MAP (
          spd => spd,
          dir => dir,
          msc => msc,
          rx => rx,
          timer_expired => timer_expired,
          error => error,
          update => update,
          clk_4b => clk_4b,
          rx_byte => rx_byte,
          tx => tx,
          linestatus => linestatus,
          start_timer => start_timer,
          stop_timer => stop_timer
        );

   -- Clock process definitions
   clk_4b_process :process
   begin
		clk_4b <= '0';
		wait for clk_4b_period/2;
		clk_4b <= '1';
		wait for clk_4b_period/2;
   end process;
 

   -- Stimulus process
   stim_proc: process
   begin		
      -- hold reset state for 100 ns.
      -- insert stimulus here 

		rx <= '1';

		-- 20000 ns
		update <= '1';
		wait for 20 ns;
		update <= '0';

		dir <= "10111010";
		spd <= "10101110";
		msc <= "11101010";
		
      wait for 2000 ns;	

		rx <= '0'; -- start
      wait for 40 ns; -- sender bit fire ganger	

		rx <= '1';
      wait for 40 ns; -- sender bit fire ganger	
		rx <= '0';
      wait for 40 ns; -- sender bit fire ganger	
		rx <= '1';
      wait for 40 ns; -- sender bit fire ganger	
		rx <= '0';
      wait for 40 ns; -- sender bit fire ganger	
		rx <= '1';
      wait for 40 ns; -- sender bit fire ganger	
		rx <= '0';
      wait for 40 ns; -- sender bit fire ganger	
		rx <= '1';
      wait for 40 ns; -- sender bit fire ganger	
		rx <= '0';

      wait for 40 ns; -- sender bit fire ganger	
		rx <= '1'; -- stop


		-- ferdig med frste sending (100 ms)
		
		wait for 4000 ns;
		
		-- 40000 ns 
		
		dir <= "11111010";
		spd <= "11101110";
		msc <= "10101010";
		
		update <= '1';
		wait for 60 ns;
		update <= '0';

		
      wait for 2000 ns;	

		rx <= '0'; -- start
      wait for 40 ns; -- sender bit fire ganger	

		rx <= '0';
      wait for 40 ns; -- sender bit fire ganger	
		rx <= '1';
      wait for 40 ns; -- sender bit fire ganger	
		rx <= '0';
      wait for 40 ns; -- sender bit fire ganger	
		rx <= '1';
      wait for 40 ns; -- sender bit fire ganger	
		rx <= '0';
      wait for 40 ns; -- sender bit fire ganger	
		rx <= '1';
      wait for 40 ns; -- sender bit fire ganger	
		rx <= '0';
      wait for 40 ns; -- sender bit fire ganger	
		rx <= '1';

      wait for 40 ns; -- sender bit fire ganger	
		rx <= '1'; -- stop

      wait;
   end process;

END;
